﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=8
@EndOfDesignText@
'WIFI

'ford can bus reading faults will not work.
'because ford starts with iso,vpw then can.  this routine 
'responds to the first request from iso.

Sub Class_Globals
	Private AStream As AsyncStreams
	Private serial As Socket
	Private ServerSock As ServerSocket
	Public foundDevices As List
	Type NameAndMac (Name As String, Mac As String)
	Public BluetoothState, ConnectionState As Boolean
	
	Private blnCanReady As Boolean
	Private x1 As Int  'counter
	
	Private blnATSH000000 As  Boolean
End Sub

Public Sub Initialize
	serial.Initialize("serial")
	ServerSock.Initialize(35000, "serversocket")
End Sub


Public Sub ConnectTo (Device As NameAndMac)
'	serial.Connect(Device.Mac)
End Sub

Private Sub Serial_Connected (Success As Boolean)
	Log("connected: " & Success)
	CallSub2(Main, "AfterConnect", Success) 'allow the activity to hide the progress dialog
	ConnectionState = Success
	If Success = False Then
		Log(LastException.Message)
		ToastMessageShow("Error connecting: " & LastException.Message, True)
	Else
		If AStream.IsInitialized Then AStream.Close
		'prefix mode! Change to non-prefix mode if communicating with non-B4X device.
'		AStream.InitializePrefix(serial.InputStream, False, serial.OutputStream, "astream")
		AStream.Initialize(serial.InputStream, serial.OutputStream, "astream")
	
		StartActivity(ChatActivity)
	End If
	NotifyOfStateChanged
End Sub

Public Sub SendMessage (msg As String)
	AStream.Write(msg.GetBytes("utf8"))
End Sub

Private Sub AStream_NewData (Buffer() As Byte)

	CallSub2(ChatActivity, "NewMessage", BytesToString(Buffer, 0, Buffer.Length, "UTF8"))

	'Send data here
	Dim msg As String = BytesToString(Buffer, 0, Buffer.Length, "UTF8")
	If msg.Contains(Chr(13)) Then
		
		msg = msg.Replace(Chr(13), "")
		
		Dim data As String = GetDataToSend(msg)
	
		If Starter.Delayms <> 0 Then
			Sleep(Starter.Delayms)
		End If
		
		Starter.Manager.SendMessage(data)

		CallSub3(ChatActivity, "LogMessage", "ELM", data)

		
	End If
End Sub

Private Sub AStream_Error
	ToastMessageShow("Connection is broken.", True)
	ConnectionState = False
	NotifyOfStateChanged
End Sub

Private Sub AStream_Terminated
	AStream_Error
End Sub

Public Sub Disconnect
	If AStream.IsInitialized Then AStream.Close
	serial.Close
End Sub


Public Sub ListenForConnections
	'this intent makes the device discoverable for 300 seconds.
'	Dim i As Intent
'	i.Initialize("android.bluetooth.adapter.action.REQUEST_DISCOVERABLE", "")
'	i.PutExtra("android.bluetooth.adapter.extra.DISCOVERABLE_DURATION", 300)
'	StartActivity(i)
	ServerSock.Listen
End Sub

Private Sub NotifyOfStateChanged
	For Each Target In Array(Main, ChatActivity)
		CallSub(Target, "UpdateState")
	Next
End Sub

Sub GetDataToSend (msg As String) As String
	Dim WhatHeader As String = Starter.strHeaders
	
	Dim cPCI As String
	If WhatHeader = "7E8" Or WhatHeader = "7EA" Or WhatHeader = "18DAF110" Or WhatHeader = "18DAF111" Then
		cPCI = "07"	'this should be length byte calculate it down below
	Else
		cPCI = ""
	End If
	
	If msg = "ATSH000000" Then	'this will allow iso to pwm transition with checking faults
		If Starter.blnISOByPass = True Then
			blnATSH000000 = True
		Else
			blnATSH000000 = False
		End If
	End If
	
	
	
	
	
	'================================================
	'================================================
	'================================================

	
	'this is testing only can remove. good for copy from debug log here.
'	If msg = "AT PPS" Then
'		Return ""
'	End If
'	If msg = "14FFFFFF" And Starter.strHeaders = "7E8" Then
'		Return "7E8037F1478" & CRLF & _
'				"7E80154" & CRLF & ">"
'		
'	End If
'	If msg = "0600" Then
'		Return "486B104600FF0000000007" & CRLF & ">"
'	End If
'	
'	If msg = "0600" Then
'		Return "81F1107F0666" & CRLF & _
'		"81F111460000555566" & CRLF & ">"
'	End If
	'================================================
	'================================================
	'================================================









	'No Data 
	If Starter.blnNoData = True Then
		Return "NO DATA" & CRLF & ">"
	End If
	
	'Custom Data Only
	If Starter.blnCustomData = True Then
		Return Starter.WhattxtCustom & CRLF & ">"
	End If
	
	
	'for ford can bus selection
	'Car Diagnostic Pro goes through 4 cycles iso,vpw,can bus
	If msg = "220200 1" Or msg = "220101 1" Then
		If blnATSH000000 = True Then	'this will trigger atsh000000 request with no data just to get by next protocol!!!
			Return "NO DATA" & CRLF & ">"
		End If
		
		If Starter.blnFordCan = True Then
			If blnCanReady = True Then
				blnCanReady = False 'reset
				Return WhatHeader & cPCI &  "620200FFFF" & CRLF & ">"
			Else
				Return "NO DATA" & CRLF & ">"
			End If
		End If
	End If
	If msg = "1003 1" Then
		blnCanReady = True
	End If
	
'	If msg = "0800" Then
'		Return "7E806480080000000" & CRLF & ">"
'	End If
'	If msg= "0100" Then
'		Return "SEARCHING..." & CRLF & _
'		"7E806410098188013" & CRLF & _
'		"7EF064100BE3EB813" & CRLF & ">"
'	End If
	
	Select Case msg
		'----------------------
		'ELM DEVICE
		'----------------------
		Case "ATZ": 		Return "OK" & CRLF & ">"
'		Case "ATZ": 		Return
		Case "ATSP0":		Return "OK" & CRLF & ">"
		Case "ATE0":		Return "OK" & CRLF & ">"
		Case "ATS0":		Return "OK" & CRLF & ">"
		Case "ATH1":		Return "OK" & CRLF & ">"
		Case "ATAL":		Return "OK" & CRLF & ">"
		Case "ATPPS":		Return "OK" & CRLF & ">"
'		Case "ATPPS":		Return "?" & CRLF & ">"
			
		Case "ATWM8110FC81": 		Return "OK" & CRLF & ">"
'		Case "ATPPS"
'			Return "00:FF F  01:FF F  02:FF F  03:32 F" & CRLF & _
'			"04:01 F  05:FF F  06:F1 F  07:09 F" & CRLF & _
'			"08:FF F  09:00 F  0A:0A F  0B:FF F" & CRLF & _
'			"0C:68 F  0D:0D F  0E:FF F  0F:FF F" & CRLF & _
'			"10:0D F  11:00 F  12:FF F  13:32 F" & CRLF & _
'			"14:FF F  15:FF F  16:FF F  17:92 F" & CRLF & _
'			"18:00 F  19:FF F  1A:FF F  1B:FF F" & CRLF & _
'			"1C:FF F  1D:FF"
			
		'----------------------
		'OBD II GENERIC
		'----------------------
'		Case "0100":		Return WhatHeader & cPCI &  "4100FFFFFFFF" & CRLF & ">"
		Case "0100"
			If WhatHeader = "7E8" Or WhatHeader = "7EA" Then
				Return "7E8" & cPCI &  "4100FFFFFFFF" & CRLF & "7E9" & cPCI & "4100FFFFFFFF" &  CRLF & "7EA" & cPCI & "4100FFFFFFFF" & CRLF & ">"
			Else
				Return WhatHeader & cPCI &  "4100FFFFFFFF" & CRLF & ">"
			End If
		Case "0120":		Return WhatHeader & cPCI &  "4120FFFFFFFF" & CRLF & ">"
		Case "0140":		Return WhatHeader & cPCI &  "4140FFFFFFFF" & CRLF & ">"
		Case "0160":		Return WhatHeader & cPCI &  "4160FFFFFFFF" & CRLF & ">"
		Case "0180":		Return WhatHeader & cPCI &  "4180FFFFFFFF" & CRLF & ">"
		Case "01A0":		Return WhatHeader & cPCI &  "41A0FFFFFFFF" & CRLF & ">"
		Case "01B0":		Return WhatHeader & cPCI &  "41B0FFFFFFFF" & CRLF & ">"
		Case "01C0":		Return WhatHeader & cPCI &  "41C0FFFFFFFF" & CRLF & ">"
		Case "01E0":		Return WhatHeader & cPCI &  "41E0FFFFFFFF" & CRLF & ">"
			
		Case "020000":		Return WhatHeader & cPCI &  "420000FFFFFF00" & CRLF& ">"
			
		Case "04":			Return WhatHeader & cPCI &  "4400FF" & CRLF & ">"
			
		Case "050001":		Return WhatHeader & cPCI &  "450001FFFFFFFF" & CRLF & ">"
		Case "052001":		Return WhatHeader & cPCI &  "452001FFFFFFFF" & CRLF & ">"
		Case "054001":		Return WhatHeader & cPCI &  "454001FFFFFFFF" & CRLF & ">"
		Case "056001":		Return WhatHeader & cPCI &  "456001FFFFFFFF" & CRLF & ">"
		Case "058001":		Return WhatHeader & cPCI &  "458001FFFFFFFF" & CRLF & ">"
		Case "05A001":		Return WhatHeader & cPCI &  "45A001FFFFFFFF" & CRLF & ">"
		Case "05C001":		Return WhatHeader & cPCI &  "45C001FFFFFFFF" & CRLF & ">"
		Case "05E001":		Return WhatHeader & cPCI &  "45E001FFFFFFFF" & CRLF & ">"
						
		Case "0600":		Return WhatHeader & cPCI &  "4600FFFFFFFFFF" & CRLF & ">"
		Case "0620":		Return WhatHeader & cPCI &  "4620FFFFFFFFFF" & CRLF & ">"
		Case "0640":		Return WhatHeader & cPCI &  "4640FFFFFFFFFF" & CRLF & ">"
		Case "0660":		Return WhatHeader & cPCI &  "4660FFFFFFFFFF" & CRLF & ">"
		Case "0680":		Return WhatHeader & cPCI &  "4680FFFFFFFFFF" & CRLF & ">"
		Case "06A0":		Return WhatHeader & cPCI &  "46A0FFFFFFFFFF" & CRLF & ">"
		Case "06C0":		Return WhatHeader & cPCI &  "46C0FFFFFFFFFF" & CRLF & ">"
		Case "06E0":		Return WhatHeader & cPCI &  "46E0FFFFFFFFFF" & CRLF & ">"
			
		Case "0800":		Return WhatHeader & cPCI &  "4800FFFFFFFF" & CRLF & ">"
		Case "0820":		Return WhatHeader & cPCI &  "482000000000" & CRLF & ">"
		Case "0840":		Return WhatHeader & cPCI &  "484000000000" & CRLF & ">"
		Case "0860":		Return WhatHeader & cPCI &  "486000000000" & CRLF & ">"
		Case "0880":		Return WhatHeader & cPCI &  "488000000000" & CRLF & ">"
		Case "08A0":		Return WhatHeader & cPCI &  "48A000000000" & CRLF & ">"
		Case "08C0":		Return WhatHeader & cPCI &  "48C000000000" & CRLF & ">"
		Case "08E0":		Return WhatHeader & cPCI &  "48E000000000" & CRLF & ">"
		Case "0801":		Return WhatHeader & cPCI &  "480100000000" & CRLF & ">"
		Case "0802":		Return WhatHeader & cPCI &  "480200000000" & CRLF & ">"
			
		Case "08000000000000":		Return WhatHeader & cPCI &  "4800FFFFFFFF" & CRLF & ">"
		Case "08200000000000":		Return WhatHeader & cPCI &  "482000000000" & CRLF & ">"
		Case "08400000000000":		Return WhatHeader & cPCI &  "484000000000" & CRLF & ">"
		Case "08600000000000":		Return WhatHeader & cPCI &  "486000000000" & CRLF & ">"
		Case "08800000000000":		Return WhatHeader & cPCI &  "488000000000" & CRLF & ">"
		Case "08A00000000000":		Return WhatHeader & cPCI &  "48A000000000" & CRLF & ">"
		Case "08C00000000000":		Return WhatHeader & cPCI &  "48C000000000" & CRLF & ">"
		Case "08E00000000000":		Return WhatHeader & cPCI &  "48E000000000" & CRLF & ">"
		Case "08010000000000":		Return WhatHeader & cPCI &  "480100000000" & CRLF & ">"
		Case "08020000000000":		Return WhatHeader & cPCI &  "480200000000" & CRLF & ">"
			
		Case "0900":		Return WhatHeader & cPCI &  "4900FFFFFFFFFF" & CRLF & ">"
		Case "0920":		Return WhatHeader & cPCI &  "4920FFFFFFFFFF" & CRLF & ">"
		Case "0940":		Return WhatHeader & cPCI &  "4940FFFFFFFFFF" & CRLF & ">"
		Case "0960":		Return WhatHeader & cPCI &  "4960FFFFFFFFFF" & CRLF & ">"
		Case "0980":		Return WhatHeader & cPCI &  "4980FFFFFFFFFF" & CRLF & ">"
		Case "09A0":		Return WhatHeader & cPCI &  "49A0FFFFFFFFFF" & CRLF & ">"
		Case "09C0":		Return WhatHeader & cPCI &  "49C0FFFFFFFFFF" & CRLF & ">"
		Case "09E0":		Return WhatHeader & cPCI &  "49E0FFFFFFFFFF" & CRLF & ">"
			
		'----------------------
		'TOYOTA CAN ENHANCED
			'----------------------
		Case "2100":		Return WhatHeader & cPCI &  "6100FFFFFFFF" & CRLF & ">"
		Case "2120":		Return WhatHeader & cPCI &  "6120FFFFFFFF" & CRLF & ">"
		Case "2140":		Return WhatHeader & cPCI &  "6140FFFFFFFF" & CRLF & ">"
		Case "2160":		Return WhatHeader & cPCI &  "6160FFFFFFFF" & CRLF & ">"
		Case "2180":		Return WhatHeader & cPCI &  "6180FFFFFFFF" & CRLF & ">"
		Case "21A0":		Return WhatHeader & cPCI &  "61A0FFFFFFFF" & CRLF & ">"
		Case "21C0":		Return WhatHeader & cPCI &  "61C0FFFFFFFF" & CRLF & ">"
		Case "21E0":		Return WhatHeader & cPCI &  "61E0FFFFFFFF" & CRLF & ">"
			
		'----------------------
		'FORD ENHANCED
		'----------------------
		Case "1003 1":		Return WhatHeader & cPCI &  "5003FF" & CRLF & ">"
		Case "3E00 1":		Return WhatHeader & cPCI &  "7E00FF" & CRLF & ">"
		Case "220200 1":	Return WhatHeader & cPCI &  "620200FFFF" & CRLF & ">"
			
		'----------------------
		'NISSAN ENHANCED
		'----------------------
		Case "1001":		Return WhatHeader & cPCI &  "5001FF" & CRLF & ">"
		Case "3E":			Return WhatHeader & cPCI &  "7E01FF" & CRLF & ">"
		Case "3F":			Return WhatHeader & cPCI &  "7F01FF" & CRLF & ">"
		Case "30":			Return WhatHeader & cPCI &  "70FFFFFFFF" & CRLF & ">"
		Case "3000":		Return WhatHeader & cPCI &  "7000FFFFFFFF" & CRLF & ">"
		Case "1A81":		Return WhatHeader & cPCI &  "5A812223352833" & CRLF & ">"
		
		'this is part of ford as well
		Case "14":			Return WhatHeader & cPCI &  "5400" & CRLF & ">"
		Case "14FF00":		Return WhatHeader & cPCI &  "5400" & CRLF & ">"
			
		Case "2211000401":	Return WhatHeader & cPCI &  "621100FFFFFFFFFF" & CRLF & ">"
		Case "2211200401":	Return WhatHeader & cPCI &  "621120FFFFFFFFFF" & CRLF & ">"
		Case "2211400401":	Return WhatHeader & cPCI &  "621140FFFFFFFFFF" & CRLF & ">"
		Case "2211600401":	Return WhatHeader & cPCI &  "621160FFFFFFFFFF" & CRLF & ">"
		Case "2212000401":	Return WhatHeader & cPCI &  "621200FFFFFFFFFF" & CRLF & ">"
		Case "2212200401":	Return WhatHeader & cPCI &  "621220FFFFFFFFFF" & CRLF & ">"
		Case "2212400401":	Return WhatHeader & cPCI &  "621240FFFFFFFFFF" & CRLF & ">"
		Case "2213000401":	Return WhatHeader & cPCI &  "621300FFFFFFFFFF" & CRLF & ">"
		Case "2213200401":	Return WhatHeader & cPCI &  "621320FFFFFFFFFF" & CRLF & ">"
		Case "2213400401":	Return WhatHeader & cPCI &  "621340FFFFFFFFFF" & CRLF & ">"
		Case "2214000401":	Return WhatHeader & cPCI &  "621400FFFFFFFFFF" & CRLF & ">"
			
		'----------------------
		'GM ENHANCED
		'----------------------		
'		Case "19CAFF00":	Return WhatHeader & cPCI &  "59CAFF00FFFFFF" & CRLF & ">"
			
	End Select
	
	
	
	
	
	
	
	
	
	
	
	
	'================================================
	'================================================
	'================================================
	'this is testing only can remove. good for copy from debug log here.
'	If msg = "0101" Then
'		Return "7E806410166775544" & CRLF & ">"
'	End If
	
'	If msg = "1902FF00" Then
'		Return "83F1105900FDDB" & CRLF & ">"
'	End If
	
'	If msg = "020000" Then
'		Return "87F110420000400000000A" & CRLF & ">"
'	End If
	
	'---------------------------------------
	'Test for multi frame with one negative
'	If msg = "0105" Then
'		Return "81F1107F0166" & CRLF & _
'		"81F1114105555566" & CRLF & ">"
'	End If
'	
'	If msg = "0101" Then
'		Return "81F1107F0166" & CRLF & _
'		"81F1114101555566" & CRLF & ">"
'	End If
'	
'	If msg = "03" Then
'		Return "81F1107F0366" & CRLF & _
'		"81F1114301555566" & CRLF & ">"
'	End If
'	
'	If msg = "0601" Then
'		Return "81F1107F0666" & CRLF & _
'		"81F111460100555566" & CRLF & ">"
'	End If
	
'	If msg = "0902" Then
'		Return "81F1107F0966" & CRLF & _
'		"81F111490200555566" & CRLF & ">"
'	End If
	
'	If msg = "0105" Then
'		Return "18DAF110037F0166" & CRLF & _
'		"18DAF111074105555566" & CRLF & ">"
'	End If
'	
'	If msg = "0101" Then
'		Return "18DAF110037F0166" & CRLF & _
'		"7EA074101555566" & CRLF & ">"
'	End If
'	
'	If msg = "03" Then
'		Return "18DAF1107F0366" & CRLF & _
'		"18DAF111074301555566" & CRLF & ">"
'	End If
'	
'	If msg = "0601" Then
'		Return "18DAF110037F0166" & CRLF & _
'		"18DAF11107460100555566" & CRLF & ">"
'	End If
'	
'	If msg = "0902" Then
'		Return "18DAF110037F0166" & CRLF & _
'		"18DAF11107490200555566" & CRLF & ">"
'	End If
	
'	If msg = "0A" Then
'		Return "18DAF10047F0A1126" & CRLF & _
'		"18DAF11047F0A1120" & CRLF & ">"
'	End If

'	If msg = "0904" Then 'it works good. it filters of the 7F
'		Return 	"83F1107F31124E" & CRLF & _
'		"87F11049040137353633B3" & CRLF & _
'		"87F110490402323735007D" & CRLF & _
'		"87F11049040300000000E0" & CRLF & _
'		"87F11049040400000000E1" & CRLF & _
'		"87F11049040537353732B7" & CRLF & _
'		"87F1104904063835380088" & CRLF & _
'		"87F11049040700000000E4" & CRLF & _
'		"87F11049040800000000E5" & CRLF & ">"
'
'	End If

	If WhatHeader = "486B10" And msg = "0902" Then
		Return "61F1104902014D414A41" & CRLF & _
		       "61F11049020258584D52" & CRLF & _
			   "61F11049020354413952" & CRLF & _
			   "61F11049020431323631" & CRLF & _
			   "61F11049020534000000" & CRLF & ">"
	End If
	
	If WhatHeader = "486B10" And msg = "0904" Then
		Return "61F1104904014A4D422A" & CRLF & _
		       "61F11049040233363736" & CRLF & _
			   "61F11049040331353030" & CRLF & _
			   "61F11049040400000000" & CRLF & ">"
	End If
	
	If WhatHeader = "486B10" And msg = "0906" Then
		Return "61F1104906011791BC82" & CRLF & _
		       "61F11049060216E062BE" & CRLF & _
			   "61F11049060300000000" & CRLF & ">"
	End If
	
	If WhatHeader = "486B10" And msg = "090A" Then
		Return "61F110490A0145434D00" & CRLF & _
		       "61F110490A022D456E67" & CRLF & _
			   "61F110490A03696E6543" & CRLF & _
			   "61F110490A046F6E7472" & CRLF & _
			   "61F110490A056F6C0000" & CRLF & ">"
	End If
	
	If WhatHeader = "486B10" And msg = "090D" Then
		Return "61F110490D0100000000" & CRLF & _
		       "61F110490D024252414E" & CRLF & _
			   "61F110490D0344203332" & CRLF & _
			   "61F110490D0431373438" & CRLF & _
			   "61F110490D0536000000" & CRLF & ">"
	End If
		
	
	'--=============------------===================

	If msg = "0902" And WhatHeader = "7E8" Then
		Return "7E810144902014D414A" & CRLF & _
			   "7E8214158584D525441" & CRLF & _
		       "7E82239523132363134" & CRLF & ">"
	End If
	
	If msg = "0904" And WhatHeader = "7E8" Then
		Return "7E810234904024A4D42" & CRLF & _
			   "7E8212A333637363135" & CRLF & _
			   "7E8223030000000004A" & CRLF & _
			   "7E8234D422A34373837" & CRLF & _
			   "7E82432363131313100" & CRLF & _
			   "7E82500000000000000" & CRLF & ">"			   
	End If
	
	If msg = "0906" And WhatHeader = "7E8"  Then
		Return "7E8100B4906021791BC" & CRLF & _
			   "7E8218216E062BE0000" & CRLF & ">"		   
	End If


'	If msg = "090A" Then
'		Return  "7E81017490A0154434D" & CRLF & _
'		"7E821002D5472616E73" & CRLF & _
'		"7E8226D69734374726C" & CRLF & _
'		"7E823000000AAAAAAAA" & CRLF & ">"	
'	End If
	
	If msg = "090A"  And (WhatHeader = "7E8" Or WhatHeader = "7EA") Then
'		Return "18DAF1111017490A0145434D" & CRLF & _
'		"18DAF1101017490A0154434D" & CRLF & _
'		"18DAF11121002D456E67696E" & CRLF & _
'		"18DAF1112265436F6E74726F" & CRLF & _
'		"18DAF11021002D5472616E73" & CRLF & _
'		"18DAF111236C000055555555" & CRLF & _
'		"18DAF110226D69734374726C" & CRLF & _
'		"18DAF1102300000055555555" & CRLF & ">"
		Return "7EA1017490A0145434D" & CRLF & _
		"7E81017490A0154434D" & CRLF & _
		"7EA21002D456E67696E" & CRLF & _
		"7EA2265436F6E74726F" & CRLF & _
		"7E821002D5472616E73" & CRLF & _
		"7EA236C000055555555" & CRLF & _
		"7E8226D69734374726C" & CRLF & _
		"7E82300000055555555" & CRLF & ">"
	End If
	
	If msg = "090D" And WhatHeader = "7E8"  Then
		Return "7E81014490D01000000" & CRLF & _
			   "7E821004252414E4420" & CRLF & _
			   "7E82233323137343836" & CRLF & ">"
		
	End If
	
	If msg = "0916" And WhatHeader = "7E8" Then
		Return "7E81023491601000000" & CRLF & _
			   "7E82101000000020000" & CRLF & _
		       "7E82200030000000400" & CRLF & _
			   "7E82300000500000006" & CRLF & _
			   "7E82400000007000000" & CRLF & _
			   "7E82508000000000000" & CRLF & ">"
	End If

	If msg = "0917" And WhatHeader = "7E8" Then
		Return "7E81023491701000000" & CRLF & _
			   "7E82101000000020000" & CRLF & _
		       "7E8220080000000FF00" & CRLF & _
			   "7E82300000500000006" & CRLF & _
			   "7E82400000007000000" & CRLF & _
			   "7E82508000000000000" & CRLF & ">"
	End If
	
	If msg = "0918" And WhatHeader = "7E8" Then
		Return "7E81023491801000000" & CRLF & _
			   "7E82101000000020000" & CRLF & _
		       "7E82200030000000400" & CRLF & _
			   "7E82300000500000006" & CRLF & _
			   "7E82400000007000000" & CRLF & _
			   "7E82508000000000000" & CRLF & ">"
	End If
	
	If msg = "0919" And WhatHeader = "7E8" Then
		Return "7E81023491901000000" & CRLF & _
			   "7E82101000000020000" & CRLF & _
		       "7E82200030000000400" & CRLF & _
			   "7E82300000500000006" & CRLF & _
			   "7E82400000007000000" & CRLF & _
			   "7E82508000000000000" & CRLF & ">"
	End If
	
	If msg = "091A" And WhatHeader = "7E8" Then
		Return "7E81023491A01000000" & CRLF & _
			   "7E82101000000020000" & CRLF & _
		       "7E82200030000000400" & CRLF & _
			   "7E82300000500000006" & CRLF & _
			   "7E82400000007000000" & CRLF & _
			   "7E82508000000000000" & CRLF & ">"
	End If
	
	If msg = "091B" And WhatHeader = "7E8" Then
		Return "7E81023491B01000000" & CRLF & _
			   "7E82130000000600000" & CRLF & _
		       "7E8220090000000B000" & CRLF & _
			   "7E8230000C0000000D0" & CRLF & _
			   "7E824000000E0000000" & CRLF & _
			   "7E825FF000000000000" & CRLF & ">"
	End If
	
	If msg = "091C" And WhatHeader = "7E8" Then
		Return "7E81023491C01000000" & CRLF & _
			   "7E82101000000020000" & CRLF & _
		       "7E82200030000000400" & CRLF & _
			   "7E82300000500000006" & CRLF & _
			   "7E82400000007000000" & CRLF & _
			   "7E82508000000000000" & CRLF & ">"
	End If
	
	If msg = "091D" And WhatHeader = "7E8" Then
		Return "7E81023491D01000000" & CRLF & _
			   "7E82101000000020000" & CRLF & _
		       "7E82200030000000400" & CRLF & _
			   "7E82300000500000006" & CRLF & _
			   "7E82400000007000000" & CRLF & _
			   "7E82508000000000000" & CRLF & ">"
	End If
	
	If msg = "091E" And WhatHeader = "7E8" Then
		Return "7E81023491E01000000" & CRLF & _
			   "7E82101000000020000" & CRLF & _
		       "7E82200030000000400" & CRLF & _
			   "7E82300000500000006" & CRLF & _
			   "7E82400000007000000" & CRLF & _
			   "7E82508000000000000" & CRLF & ">"
	End If
	
	If msg = "091F" And WhatHeader = "7E8" Then
		Return "7E81023491F01000000" & CRLF & _
			   "7E82101000000020000" & CRLF & _
		       "7E82200030000000400" & CRLF & _
			   "7E82300000500000006" & CRLF & _
			   "7E82400000007000000" & CRLF & _
			   "7E82508000000000000" & CRLF & ">"
	End If
	
'	If msg = "2211A201" Then 'checking GM autoscan ...its fine and did not report in listview??/
'		Return "6CF1107F2211A20131E0" & CRLF & ">"
'	End If
	
'	If msg = "0105" Then
'		Return "83F1107F01121E" & CRLF & _
'		"83F11141054E1A" & CRLF & ">"
'	End If
	'-----------------------------------------------------
	If msg = "07" And Starter.strHeaders = "7E8" Then
		Return "7E8100A470402630269" & CRLF & _
				"7E82102720266FFFFFF" & CRLF & ">"
	End If
	
	
	If msg = "14FFFFFF" And (Starter.strHeaders = "7E8" Or Starter.strHeaders = "486B10") Then
		If Starter.strHeaders = "7E8" Then
			Return "7E8037F1478" & CRLF & _
			"7E80154" & CRLF & ">"
		Else
'			Return	"68F11054" & CRLF & ">"
		End If
	End If
	
	
'	If msg = "13" Then	'Ford Non Can Faults
'			Return "A4F1107F1300000062" & CRLF & _
'					"A4F1105398690000000041" & CRLF & ">"
'	End If
	If msg = "13" And Starter.strHeaders = "486B10" Then	'Ford Non Can Faults
		x1 = x1 + 1
		If x1 >= 3 Then x1 = 1
		Select Case x1
			Case 1
				Return "A4F11053515551455234D2A4F128539676000000001C" & CRLF & ">"
			Case 2
				Return "A4F1105398690000000041" & CRLF & ">"
		End Select
	End If
	
'	If msg = "A3" Then	'Nissan Faults
'		Return "85FC10E30104000004010004020079" & CRLF & ">"
'	End If
'	
	If msg = "020200" Then	'Generic Mode 2 Faults
		Return WhatHeader & cPCI &  "4202000193" & CRLF & ">"
	End If
	
	If WhatHeader = "486B10" Then
		If msg = "0104" Then
			x1 = x1 + 1
			Select Case x1
				Case 1
					Return "486B10410420" & CRLF & ">"
				Case 2
					Return "486B10410440" & CRLF & ">"
				Case 3
					Return "486B10410460" & CRLF & ">"
				Case 4
					Return "486B10410480" & CRLF & ">"
				Case Else
					x1 = 0
					Return "486B104104A0" & CRLF & ">"
			End Select
		End If
	End If
	
	
'	Let’s go back To our service 19 example...
'	ECU sends response message – 59 02 08 06 20 13 8A
'	 59 = ReadDTCInformation service response identifier (SID)
'	 02 = reportDTCByStatusMask mode (echoed from request)
'	 08 = confirmedDTC status mask (echoed from request)
'	 062013 = DTC Generator Control Circuit – circuit open
'	 8A = status mask For DTC 062013
'	 8A = 1000 1010
'	> Bit 7 – warningIndicatorRequested = 1
'	> Bit 3 – confirmedDTC = 1
'	> Bit 1 – testFailedThisMonitoringCycle = 1
'	> So, Not only Is the DTC confirmed,
'	but it continues To fail And Is illuminating the engine lamp

	
	'----------------------------------
	'example: 31030202 = 7E81008710302022014, 7E82164000000000000
	If msg = "31010202" And Starter.strHeaders = "7E8" Then	'Ford KOEO HS 14229 
		Return "7E8067101020200" & CRLF & ">"
	End If
	
	If msg = "31030202" And Starter.strHeaders = "7E8" Then	'Ford Faults
		x1 = x1 + 1
		If x1 >= 3 Then x1 = 1
		Select Case x1
			Case 1
				Return "7E8067103020200" & CRLF & ">"
			Case 2
				Return "7E8100D710302022014" & CRLF & _ 'is it P0220, P2014. should be P2014
				       "7E82164000301FFFF00" & CRLF & ">"
				
		End Select
	End If

	'----------------------------------	
	'Ford Diesel CAN BUS
	If msg = "329100" And Starter.strHeaders = "7E8" Then
		x1 = x1 + 1
		Select Case x1
			Case 1
					Return "7E8067F3200" & CRLF & ">"
			Case Else
				x1 = 0
					Return "7E806729100" & CRLF & ">"
		End Select
	End If
	If msg = "3391" And Starter.strHeaders = "7E8" Then
		Return "7E8067391010302" & CRLF & ">"
	End If
	If msg = "3302" And Starter.strHeaders = "7E8" Then
		Return "7E81013730204030203" & CRLF & _
		    	"7E82103030403050000" & CRLF & ">"
	End If
	
	'----------------------------------
	If msg = "1800FF00" And Starter.strHeaders = "7E8" Then	'ford faults
		If Starter.blnMode19 = False Then
			x1 = x1 + 1
			x1 = 2
			Select Case x1
				Case 1
					Return "7E8100858010301FF03" & CRLF & _
					"7E82102FF" & CRLF & ">"
				Case 2
					Return "7E8100B58030000FF00" & CRLF & _
					"7E8218CFF1000FF0000" & CRLF & ">"

				Case Else
					x1 = 0
					Return "7E8100658010301FF03" & CRLF & _
					"7E82158FF" & CRLF & ">"			
			End Select
		End If
	End If

	'----------------------------------
'	If msg = "19028F" Then	'Ford Faults
'		If Starter.blnMode19 = True Then
'
'				Return "7E8037F19" & CRLF & _
'						"7E810145902FF031500" & CRLF & _
'							"7E821AF044600ECC109" & CRLF & _
'						   "7E8220068E10B006C00" & CRLF & ">"
'		End If
'	End If
	'example good data 5902080301
'	If msg = "19028F" Then
'		Return "NO DATA" & CRLF & ">"
'	End If
	If msg = "19028F" And (Starter.strHeaders = "7E8" Or Starter.strHeaders = "7EA") Then	'Ford Faults
		If Starter.blnMode19 = True Then
			x1 = x1 + 1
			Select Case x1
				Case 1
					Return "7E8065902080301FFFF" & CRLF & ">"
				Case 2
					Return "7E810145902FF031500" & CRLF & _
							"7E821AF044600ECC109" & CRLF & _
						   "7E8220068E10B006C00" & CRLF & ">"
				Case 3
					Return "7E80459020800" & CRLF & ">"
				Case 4
					Return "7E8065902081111FFFF" & CRLF & ">"
				Case 5
					Return "7E810145902CAC19600" & CRLF & _
					"7E8212BC249002BE101" & CRLF & _
					"7E822002BF000042800" & CRLF & ">"

				Case Else
					x1 = 0
					Return "7E810145902FF031500" & CRLF & _
							"7EA065902FF00" & CRLF & _
							"7E82159594600ECC109" & CRLF & _
						   "7E8220068E10B006C00" & CRLF & ">"
			End Select
		End If
	End If

	'----------------------------------	
	If msg.Length >= 4 And WhatHeader = "486B10" Then	'GM Faults
		If msg.SubString2(0,2) = "19" Then	
			x1 = x1 + 1
			If x1 >= 3 Then x1 = 1
			Select Case x1
				Case 1
					Return "6CF110590301B998" & CRLF & ">"
				Case 2
					Return "6CF110590332B998" & CRLF & _
					"6CF110590420BF70" & CRLF & _
					"6CF110590449FB9E" & CRLF & _
					"6CF110590455299F" & CRLF & _
					"6CF110590000FF10" & CRLF & ">"			
			End Select
		End If
	End If

	'----------------------------------	
	If msg = "A3" And WhatHeader = "486B10" Then	'Nissan Faults
		Return "88FC10E302013800011800CB" & CRLF & ">"
	End If
		
'	If msg = "0904" Then calibration id good
'		Return "7E81013490401424843" & CRLF & _
'		"7E91013490401544248" & CRLF & _
'		"7E8214E3338474D322A" & CRLF & _
'		"7E921305A33384E4134" & CRLF & _
'		"7E922000000000000AA" & CRLF & _
'		"7E8222A434B34412A00" & CRLF & ">"
'
'	End If
	
'	If msg = "0904" Then 'Calibration id looks good
'		Return  "486B1049040131323537D7" & CRLF & _
'		"486B10490402373935369D" & CRLF & _
'		"486B104904030000000063" & CRLF & _
'		"486B104904040000000068" & CRLF & _
'		"486B104904053132353762" & CRLF & _
'		"486B10490406393035310D" & CRLF & _
'		"486B1049040700000000D6" & CRLF & _
'		"486B1049040800000000AA" & CRLF & _
'		"486B1049040931323537A0" & CRLF & _
'		"486B1049040A3930373604" & CRLF & _
'		"486B1049040B0000000014" & CRLF & _
'		"486B1049040C000000001F" & CRLF & _
'		"486B1049040D3132353715" & CRLF & _
'		"486B1049040E3431373318" & CRLF & _
'		"486B1049040F00000000A1" & CRLF & _
'		"486B104904100000000033" & CRLF & _
'		"486B104904113132353739" & CRLF & _
'		"486B1049041239313534B0" & CRLF & _
'		"486B10490413000000008D" & CRLF & _
'		"486B104904140000000086" & CRLF & _
'		"486B10490415313235378C" & CRLF & _
'		"486B1049041633363733FF" & CRLF & _
'		"486B104904170000000038" & CRLF & _
'		"486B104904180000000044" & CRLF & ">"
'	End If
'	
'	If msg = "0602" Then 'iso checking looks ok
'		Return	"486B10460284000000009E" & CRLF & _
'		"486B104602667FB58079A0" & CRLF & _
'		"486B1046023600000014FF" & CRLF & _
'		"486B1046028680008032C6" & CRLF & _
'		"486B104602D07FB580AF7B" & CRLF & _
'		"486B104602608000812CFD" & CRLF & _
'		"486B104602B00000013EA4" & CRLF & _
'		"486B104602C00000FFFF31" & CRLF & _
'		"486B10460262800080007E" & CRLF & _
'		"486B104602728000800090" & CRLF & _
'		"486B104602910000005071" & CRLF & _
'		"486B1046022100000028CC" & CRLF & _
'		"486B104602717FB5806409" & CRLF  & ">"
'	End If

	If msg = "0601"  And (WhatHeader = "7E8" Or WhatHeader = "7EA")  Then
		Return "7E8105B4601010A0000" & CRLF & _
		"7E8210000000001020A" & CRLF & _
		"7E82200000000000001" & CRLF & _
		"7E823030A0000000000" & CRLF & _
		"7E8240001040A000000" & CRLF & _
		"7E82500000001051000" & CRLF & _
		"7E82600000000000106" & CRLF & _
		"7E82710000000000000" & CRLF & _
		"7EA105B4601010A0000" & CRLF & _
		"7EA210000000001800A" & CRLF & _
		"7EA2200000000000001" & CRLF & _
		"7EA23810E0000000000" & CRLF & _
		"7E82801902000000000" & CRLF & _
		"7E82900000191200000" & CRLF & _
		"7E82A00000000019210" & CRLF & _
		"7E82B00000000000001" & CRLF & _
		"7E82C93100000000000" & CRLF & _
		"7E82D00000000000000" & CRLF &  ">"
'		Return "7E8101C4601010A0000" & Chr(10)  & CRLF & Chr(10) & _
'		"7E8210000000001800A" & CRLF & Chr(10)  & Chr(10)  & _
'		"7E82200000000000001" & CRLF & Chr(10)  & Chr(10)  & _
'		"7E823810E0000000000" & CRLF & Chr(10)  & Chr(10)  & _
'		"7E82400000000000000" & CRLF & ">"	
	End If
	
'	If msg = "0606" Then
'		Dim WhatPid As String = msg.SubString2(2,4)
'		Dim Data As String
'		Dim WhatData As String
'		
'		For x = 0 To 12
'			Data = Rnd(0,255)
'			Data = Bit.ToHexString(Data)
'			Data = Data.ToUpperCase
'			If Data.Length = 1 Then Data = "0" & Data
'			WhatData = WhatData & Data
'		Next
'		
'		Return WhatHeader & cPCI &  "46" & WhatPid & WhatData & CRLF & ">"
'	End If

'	If msg = "020300" Then
'		Return WhatHeader & cPCI &  "420300FFFFFFFF" & CRLF & ">"
'	End If

'	If msg = "03" Then
'		Return "18DAF1101018430B00160017" & CRLF & _
'				"18DAF110210018" & CRLF & ">"
'
'	End If

'	If msg = "03" Then
'		Return "7E81018430B00160017" & CRLF & _
'				"7EA027F0344" & CRLF & _		'this is problem and solved yet!!!
'				"7E82100300036013201" & CRLF & _
'				"7E82234013501380140" & CRLF & _
'				"7E82301410481AAAAAA" & CRLF & ">"
'	End If
	
	'----------------------------------	
	If msg = "03" And (Starter.strHeaders = "7E8" Or Starter.strHeaders = "7EA") Then
		x1 = x1 + 1
		
		Select Case x1
		
			Case 1
				Return "7E81018430B00160017" & CRLF & _
				"7EA024300" & CRLF & _
				"7E82100300036013201" & CRLF & _
				"7E82234013501380140" & CRLF & _
				"7E82301410481AAAAAA" & CRLF & ">"
			Case 2
				Return "7E80443010300" & CRLF & ">"
			Case 3
				Return "7E806430203010302" & CRLF & ">"
			Case 4
				Return "7E80743020301030200" & CRLF & ">"
			Case 5
				Return "7E81018430B03000301" & CRLF & _
				"7EA0743020301030200" & CRLF & _
				"7E82143030303030403" & CRLF & _
				"7E82205030603070308" & CRLF & _
				"7E8230309030AAAAAAA" & CRLF & ">"

			Case 6
				Return "7E81018430B00160017" & CRLF & _
				"7EA027F0344" & CRLF & _		'this is problem and solved yet!!!
				"7E82100300036013201" & CRLF & _
				"7E82234013501380140" & CRLF & _
				"7E82301410481AAAAAA" & CRLF & ">"
				
			Case Else
				x1 = 0
				Return "7E8024300" & CRLF & ">"
'				Return "7E8027F0344" & CRLF & ">"	'can't do this because it will repeat request and goes to other
		End Select
		
	End If
	
	
	If msg = "090F" And WhatHeader = "7E8" Then	'EROTAN Mode 9 0F
		Return "7E81014490F01000000" & CRLF & _
			   "7E82100444F432D4352" & CRLF & _
			   "7E8222D393334353637" & CRLF & ">"
	End If
	
	If msg = "0912" And WhatHeader = "7E8" Then
		Return "7E805491201095600" & CRLF & ">"	
	End If
	
	
	If msg = "0172" And WhatHeader = "7E8" Then
		Return "7E807417200FB000000" & CRLF & ">"
	End If
	
	If msg = "010C" And WhatHeader = "7E8" Then
		Dim rn1 As String = Rnd(0,69)
		rn1 = Bit.ToHexString(rn1)
		If rn1.Length = 1 Then
			rn1 = "0" & rn1
		End If
		
		Dim rn2 As String = Rnd(0,255)
		rn2 = Bit.ToHexString(rn2)
		If rn2.Length = 1 Then
			rn2= "0" & rn1
		End If
		Return "7E807410C" & rn1 & rn2 & "FFFFFF" & CRLF & ">"
		Log(rn1)
	End If
	'end of testing----------------------------------------------------------
	'================================================
	'================================================
	'================================================


















	'No Data After 
	If Starter.blnNoData2 = True Then
		Return "NO DATA" & CRLF & ">"
	End If
	
	
	
	
	
	
	'----------------------
	'ELM DEVICE	
	'----------------------
	If msg.Length >= 4 Then		
		If msg.SubString2(0,4) = "ATAT" Then
			Return  "OK" & CRLF & ">"
		End If
		If msg.SubString2(0,4) = "ATST" Then
			Return  "OK" & CRLF & ">"
		End If
		
		If msg.SubString2(0,2) = "AT" Then
			Return "OK" & CRLF & ">"
		End If		
	End If
	
	'Headers + 7 Data Bytes = VPW, PWM and ISO
	'Headers + 8 Data Bytes = CAN 
	'----------------------
	'OBD II GENERIC
	'----------------------	
	If msg.Length >= 4 Then
		If msg.SubString2(0,2) = "01" Then
			Dim WhatPid As String = msg.SubString2(2,4)
			
			Dim Data As String
			Dim WhatData, WhatDataResult, WhatDataResult2 As String
			
			If WhatHeader = "486B10" Or WhatHeader = "486B11" Then
				Dim k As Int = Rnd(0,1)	'was Rnd(0,11) for multi frame but error due to j1979 can't handle multiframe for non canbus.  but it the code is disabled in communicationroutine service to resolve it.  not sure if any multiframe is available in mode1.  2006 pids after Hex 66 had multiframe
				
				For g = 0 To k
					'VPW,ISO and PWM is 7 Data bytes + 3 Header Bytes and 1 Checksum which elm does not show it?
					WhatData = ""
					For x = 0 To 4
						Data = Rnd(0,255)
						Data = Bit.ToHexString(Data)
						Data = Data.ToUpperCase
						If Data.Length = 1 Then Data = "0" & Data
						WhatData = WhatData & Data
					Next
					WhatDataResult = WhatHeader & "41" & WhatPid & WhatData & CRLF
					WhatDataResult2 = WhatDataResult2 & WhatDataResult
				Next
				WhatData = WhatDataResult2
			Else
				Dim k As Int = Rnd(0,11)	
				For g = 0 To k
					'VPW,ISO and PWM is 7 Data bytes + 3 Header Bytes and 1 Checksum which elm does not show it?
					WhatData = ""
					
					Dim cMax As Int 
					If k = 0 Then
						cMax = 4
					Else
						If g = 0 Then
							cMax = 3
						Else
							cMax = 6
						End If
					End If
						
					For x = 0 To cMax
						Data = Rnd(0,255)
						Data = Bit.ToHexString(Data)
						Data = Data.ToUpperCase
						If Data.Length = 1 Then Data = "0" & Data
						WhatData = WhatData & Data
					Next

					Select Case g
						Case 0
								'only single frame do this
								If k = 0 Then
									WhatDataResult = WhatHeader  & "07" & "41" & WhatPid & WhatData & CRLF
								Else
									WhatDataResult = WhatHeader & "10" & "14" & "41" & WhatPid & WhatData & CRLF
								End If
						Case 1,5,8,11: WhatDataResult = WhatHeader & "20"  & WhatData & CRLF
						Case 2,6,9: WhatDataResult = WhatHeader & "21"  & WhatData & CRLF
						Case 3,7,10: WhatDataResult = WhatHeader & "22"  & WhatData & CRLF
					End Select
					WhatDataResult2 = WhatDataResult2 & WhatDataResult
				Next
				WhatData = WhatDataResult2
			End If
						
			Return WhatData & CRLF & ">"
		End If
	End If
	
	If msg.Length >= 4 Then
		If msg.SubString2(0,2) = "02" Then
			Dim WhatPid As String = msg.SubString2(2,6)
			Dim Data As String
			Dim WhatData As String
			
			Select Case msg.SubString2(2,6)
			
			Case "0000", "2000", "4000", "6000", "8000", "A000"
				If WhatHeader = "486B10" Then
					Return WhatHeader  & "42" & WhatPid & "FFFFFFFF" & CRLF& ">"
				Else
					Return WhatHeader  & "07" & "42" & WhatPid & "FFFFFFFF" & CRLF	& ">"
				End If
			Case Else
				For x = 0 To 39
					Data = Rnd(0,255)
					Data = Bit.ToHexString(Data)
					Data = Data.ToUpperCase
					If Data.Length = 1 Then Data = "0" & Data
					WhatData = WhatData & Data
				Next
			End Select
			Return WhatHeader & cPCI &  "42" & WhatPid & WhatData & CRLF & ">"
		End If
	End If
	
	If msg.Length >= 4 Then
		If msg.SubString2(0,2) = "05" Then
			Dim WhatPid As String = msg.SubString2(2,6)
			Dim Data As String
			Dim WhatData As String
			
			For x = 0 To 12
				Data = Rnd(20,40)
				Data = Bit.ToHexString(Data)
				Data = Data.ToUpperCase
				If Data.Length = 1 Then Data = "0" & Data
				WhatData = WhatData & Data
			Next
			
			Return WhatHeader & cPCI &  "45" & WhatPid & WhatData & CRLF & ">"
		End If
	End If
	
	If msg.Length >= 4 Then
		If msg.SubString2(0,2) = "06" Then
			Dim WhatPid As String = msg.SubString2(2,4)
			Dim Data As String
			Dim WhatData As String
			
			For x = 0 To 12
				Data = Rnd(0,255)
				Data = Bit.ToHexString(Data)
				Data = Data.ToUpperCase
				If Data.Length = 1 Then Data = "0" & Data
				WhatData = WhatData & Data
			Next
			
			Return WhatHeader & cPCI &  "46" & WhatPid & WhatData & CRLF & ">"
		End If
	End If
		
	Select Case msg.SubString2(0,2)
					
		Case "03", "07", "0A"
			Dim WhatPid As String
			
			Select Case msg.SubString2(0,2)
				Case "03": WhatPid = "43"
				Case "07": WhatPid = "47"
				Case "0A": WhatPid = "4A"
			End Select
			
			Dim Data As String
			Dim WhatData As String
			
			If Starter.blnShowValid = True Then
				Select Case Starter.strHeaders
					Case "7E8", "7EA", "18DAF110", "18DAF111"
						'This is 2 headers and new filtration works really good!!
'						Return "7E9" & "07" & WhatPid & "FF0601000000" & CRLF & WhatHeader & "10" & "19" & WhatPid & "FF04010402" & CRLF & WhatHeader & "21" & "47470301030203" & CRLF & WhatHeader & "22" & "03040000000000" & CRLF & ">"
'						Return "7E9" & "07" & WhatPid & "FF0601000000" & CRLF & WhatHeader & "10" & "19" & WhatPid & "FF04010402" & CRLF & WhatHeader & "21" & "47470301030203" & CRLF & WhatHeader & "22" & "03040000000000" & CRLF & ">"
					
						Return WhatHeader & "10" & "19" & WhatPid & "FF04010402" & CRLF & WhatHeader & "21" & "04030301030203" & CRLF & WhatHeader & "22" & "03040000000000" & CRLF & ">"

'						Return WhatHeader & "10" & "19" & WhatPid & "FF04010402" & CRLF & WhatHeader & "21" & "43030301030203" & CRLF & WhatHeader & "22" & "03040000000000" & CRLF & ">"
						
					Case Else
						WhatData = "04012014111111" & CRLF & WhatHeader & WhatPid & "03010302030311"
				End Select
			Else				
				For x = 0 To 18
					Data = Rnd(0,255)
					Data = Bit.ToHexString(Data)
					Data = Data.ToUpperCase
					If Data.Length = 1 Then Data = "0" & Data
					WhatData = WhatData & Data
				Next
			End If
			
			Return WhatHeader & cPCI &  WhatPid & WhatData & CRLF & ">"
			
	End Select
	
	If msg.Length >= 4 Then
		If msg.SubString2(0,2) = "09" Then
			Dim WhatPid As String = msg.SubString2(2,4)
			
			Dim Data As String
			Dim WhatData As String
			
			
			For x = 0 To 66
				Data = Rnd(0,255)
				Data = Bit.ToHexString(Data)
				Data = Data.ToUpperCase
				If Data.Length = 1 Then Data = "0" & Data
				WhatData = WhatData & Data
			Next
			
			Return WhatHeader & cPCI &  "49" & WhatPid & WhatData & CRLF & ">"
		End If
	End If
	
	'----------------------
	'NISSAN ENHANCED
	'----------------------
	If msg.Length >= 6 Then
		If msg.SubString2(0,4) = "2211" Or msg.SubString2(0,4) = "2212" Or msg.SubString2(0,4) = "2213" Or msg.SubString2(0,4) = "2214" Then
			Dim WhatPid As String = msg.SubString2(2,6)
			
			Dim Data As String
			Dim WhatData As String
			For x = 0 To 10
				Data = Rnd(0,255)
				Data = Bit.ToHexString(Data)
				Data = Data.ToUpperCase
				If Data.Length = 1 Then Data = "0" & Data
				WhatData = WhatData & Data
			Next
			
			Return WhatHeader & cPCI &  "62" & WhatPid & WhatData & CRLF & ">"
			
		End If
		
	End If
	
	If msg.Length >= 2 Then
		If msg.SubString2(0,2) = "A3" Then
			
			Dim Data As String
			Dim WhatData As String
			For x = 0 To 25
				Data = Rnd(0,255)
				Data = Bit.ToHexString(Data)
				Data = Data.ToUpperCase
				If Data.Length = 1 Then Data = "0" & Data
				WhatData = WhatData & Data
			Next
			
			Return WhatHeader & cPCI &  "E3" & WhatData & CRLF & ">"
			
		End If
		
	End If

	'----------------------
	'GM ENHANCED
	'----------------------
	'----------------------
	'FORD ENHANCED	
	'----------------------
	If msg.Length >= 6 Then
		If msg.SubString2(0,2) = "22" Then
			Dim WhatPid As String = msg.SubString2(2,6)
			
			Dim Data As String
			Dim WhatData As String
			For x = 0 To 10
				Data = Rnd(0,255)
				Data = Bit.ToHexString(Data)
				Data = Data.ToUpperCase
				If Data.Length = 1 Then Data = "0" & Data
				WhatData = WhatData & Data
			Next
	
			Return WhatHeader & cPCI &  "62" & WhatPid & WhatData & CRLF & ">"
			
		End If
	End If
	
	If msg.Length >= 2 Then
		If msg.SubString2(0,2) = "19" Then
			
			Dim Data As String
			Dim WhatData As String
			For x = 0 To 10
				Data = Rnd(0,255)
				Data = Bit.ToHexString(Data)
				Data = Data.ToUpperCase
				If Data.Length = 1 Then Data = "0" & Data
				WhatData = WhatData & Data
			Next
	
			Return WhatHeader & cPCI &  "59" & WhatData & CRLF & ">"
			
		End If
	End If

	'----------------------
	'TOYOTA ENHANCED
	'----------------------
	
	If msg.Length >= 2 Then
		If msg.SubString2(0,2) = "21" Then
			Dim WhatPid As String = msg.SubString2(2,4)
			
			Dim Data As String
			Dim WhatData, WhatDataResult, WhatDataResult2 As String
			
			Dim k As Int = Rnd(0,11)
			For g = 0 To k
				'VPW,ISO and PWM is 7 Data bytes + 3 Header Bytes and 1 Checksum which elm does not show it?
				WhatData = ""
				
				Dim cMax As Int
				If k = 0 Then
					cMax = 4
				Else
					If g = 0 Then
						cMax = 3
					Else
						cMax = 6
					End If
				End If
					
				For x = 0 To cMax
					Data = Rnd(0,255)
					Data = Bit.ToHexString(Data)
					Data = Data.ToUpperCase
					If Data.Length = 1 Then Data = "0" & Data
					WhatData = WhatData & Data
				Next

				Select Case g
					Case 0
						'only single frame do this
						If k = 0 Then
							WhatDataResult = WhatHeader  & "07" & "61" & WhatPid & WhatData & CRLF
						Else
							WhatDataResult = WhatHeader & "10" & "14" & "61" & WhatPid & WhatData & CRLF
						End If
					Case 1,5,8,11: WhatDataResult = WhatHeader & "20"  & WhatData & CRLF
					Case 2,6,9: WhatDataResult = WhatHeader & "21"  & WhatData & CRLF
					Case 3,7,10: WhatDataResult = WhatHeader & "22"  & WhatData & CRLF
				End Select
				WhatDataResult2 = WhatDataResult2 & WhatDataResult
			Next
			WhatData = WhatDataResult2
			
			Return WhatData & CRLF & ">"
		End If
	End If
	
	Return "NO DATA" & CRLF & ">"
	
End Sub

Private Sub serversocket_NewConnection (Successful As Boolean, NewSocket As Socket)
Log("server socket")
	'server accepted client
	If Successful Then
		StartAStream(NewSocket.InputStream, NewSocket.OutputStream)
		StartActivity(ChatActivity)
	End If
	ServerSock.Listen
End Sub
Private Sub StartAStream (Inn As InputStream, out As OutputStream)
	Log("StartAStream")
	AStream.Initialize(Inn, out, "astream")

End Sub




